
import Promise from '../vendors/es6-promise';
import { API_HOST, SERVICE_HOST } from './config';
import { GET, POST } from './request';

function getQRCodeSource(code) {
  return new Promise(function (resolve, reject) {
    let param = {
      md5Param: code,
      miniapp_type: 29  
    }
    GET(API_HOST +'/wechat/miniapp/getMiniAppRealParam', param)
      .then(data => {
        if (data.code == 200) {
          if(data.data){
            resolve(JSON.parse(data.data));
          }
        }else {
          reject(null);
        }
      })
      .catch(error => {
        reject(error);
      });
  })
}

export {
  getQRCodeSource,
}