import { API_HOST, SERVICE_HOST } from '../../libs/config';
import { GET, POST } from '../../libs/request';
import { getYHStorageSync } from '../../utils/util';
import {
  yasReport,
  YB_PAGE_OPEN_L
} from '../../libs/yas';

let CACH_KEY = 'country_cach';
let CHOOSED_COUNTRY_ID = 'CHOOSED_COUNTRY_ID'
let CHOOSED_COUNTRY_NAME = 'CHOOSED_COUNTRY_NAME'


Page({
  /**
   * 页面的初始数据
   */
  data: {
    list:[]
  },
  getArea: function () {
    let param={
      method: 'app.passport.getArea'
    }
    GET(API_HOST,param)
    .then(json=>{
      if(json && json.code == 200){
        let datalist = json.data;
        if(datalist && datalist.length>0){
          // wx.setStorageSync(CACH_KEY, datalist);
          this.setData({
            list: datalist
          })
          wx.setStorage({
            key: CACH_KEY,
            data: datalist,
          })
        }
      }else{
        this.useCache();
      }
    })
    .catch(error=>{
      this.useCache();
    })
  },
  useCache:function(){
    let datalist = getYHStorageSync(CACH_KEY,'choosecountry');
    this.setData({
      list: datalist
    })
  },
  chooseCountry:function(e){
    let country = e.currentTarget.dataset.country;
    let country_area = e.currentTarget.dataset.area;
    let country_id = e.currentTarget.dataset.id;

    wx.setStorage({
      key: CHOOSED_COUNTRY_ID,
      data: country_area,
    })

    wx.setStorage({
      key: CHOOSED_COUNTRY_NAME,
      data: country,
    })
    // console.log('选择了国家：' + country+":::"+country_area+":::"+country_id)

    wx.navigateBack({
      delta: 1
    })

  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.getArea();
    yasReport(YB_PAGE_OPEN_L);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
  
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
  
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
  
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
  
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
  
  }
})