// page/subPackage/pages/zeroSell/components/action-bar.js

import ZeroSellService from '../service/zero-sell'
import router from '../router/router'
import { postTmplId } from '../../../libs/tmplIdMessage.js'
const event = global.event;

var app = getApp();

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    status: {
      type: Number,
      value: 1
    },
    num: {
      type: Number,
      value: 0
    },
    shareUid: {
      type: Number,
      value: 0
    },
    actPrizeId: {
      type: Number,
      value: 0
    },
    copyText: {
      type: String,
      value: ''
    },
    text: {
      type: String,
      value: ''
    },
    type:{
      type: Number,
      value:0
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    show: false,
    code: '',
    error: false,
    fellow: false,
    msgChecked: true
  },

  ready() {
    this.service = new ZeroSellService();
  },

  /**
   * 组件的方法列表
   */
  methods: {
    msgSwitch() {
      this.setData({
        msgChecked: !this.data.msgChecked
      })
    },
    fetchCode() {
      wx.showLoading({
        mask: true
      });
      event.emit('user-is-login', {
        logged: this.logged.bind(this), loginSuccess: function () {
        }
      });
    },
    logged(userInfo) {
      this.service.fetchCode({
        shareUid: this.properties.shareUid,
        uid: app.getUid(),
        actPrizeId: this.properties.actPrizeId,
        userThumb: userInfo.avatarUrl,
        userName: userInfo.nickName
      }).then(result => {
        wx.hideLoading();
        if (result.code === 200) {
          this.setData({
            show: true,
            code: result.data.prizeCode
          });
          this.triggerEvent('gaincodesuccess', this.properties.actPrizeId);
        } else {
          this.setData({
            error: true,
            errorText: result.message
          });
        }
      });
    },
    goShare() {
      this.triggerEvent('share');
      this.setData({
        show: false,
        error: false,
        fellow: false
      });
    },

    hadJoinToShare() {
      console.log(this.data.msgChecked)
      let that = this
      if (this.data.msgChecked) {
        let tmplIds = ['2PMsn85-733813unyw1EGVLQY5LE6BbHIQ_sGM-F-3U', 'l3YAeDrrqspEFpNpOofZxXAk_wKH3zdjNBVZmX42q5c'];
        postTmplId({
          tmplIds
        }).then(res => {
          that.goShare();
          that.triggerEvent('getcode');
        }).catch(err => {
          console.log(err)
        })
      } else {
        this.goShare();
        this.triggerEvent('getcode');
      }
    },

    goMyList() {
      wx.reLaunch({
        url: '/pages/zeroSell/index?tabIndex=3&reload=0',
      })
    },

    goList() {
      wx.navigateTo({
        url: '/pages/zeroSell/index?reload=0',

      })

    },

    cancelFellow(){
      this.setData({
        fellow: false
      })
    },

    cancelAlert() {
      this.setData({
        show: false,
        error: false
      });

      this.triggerEvent('getcode');
    },

    openFellowAlert() {
      this.setData({
        fellow: true
      });
    },

    hiddenAlert(e) {
      this.setData({
        show: false,
        error: false,
        fellow: false
      });
      this.triggerEvent('getcode');
    },

  }
})
