// page/subPackage/pages/zeroSell/components/prize-item.js

import router from '../router/router'

const PRODUCT_STATUS = {
  UNKNOWN: 0, // 活动关闭
}

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    item: {
      type: Object
    },
    tabIdx: String
  },

  /**
   * 组件的初始数据
   */
  data: {
    show: false,
    text: '',
    copyText: '',
    type: 0
  },

  /**
   * 组件的方法列表
   */
  methods: {
    goFellow(e) {
      let text = JSON.parse(e.target.dataset.text || "{}");
      this.setData({
        show: true,
        text: text.miniappTip || '',
        copyText: text.miniappCopy || '',
        type: text.miniappType || 0
      })
    },
    onOk() {
      this.setData({
        show: false
      })
    },
    goDetail() {
      if (this.properties.item.status === PRODUCT_STATUS.UNKNOWN) {
        wx.showModal({
          title: 'OOPS',
          content: '活动已下线',
          showCancel: false
        });
      } else {
        router.go('detail', {
          tabIdx: +this.data.tabIdx + 1,
          fromPageParam: +this.data.tabIdx + 1,  
          actPrizeId: this.properties.item.act_prize_id
        });
      }
    }
  },

  ready() {
  }
})
