'use strict'
import { getYHStorageSync } from './util';

const Search_History_Key = 'Search_History_Key';

function addSearchHistory(keyword) {
  if (!keyword.trim()) {
    return false;
  }
  
  let list = fetchSearchHistory();
  let newList = list.filter((value, i) => {
    return value != keyword;
  });
  newList = [keyword, ...newList];
  newList = newList.slice(0, 10);
  try {
    wx.setStorageSync(Search_History_Key, newList);
  } catch (e) {
  
  }

  return true;
}


function removeSearchHistory(keyword) {
  let list = fetchSearchHistory();
  let newList = list.filter((value, i) => {
    return value != keyword;
  });
  wx.setStorage({
    key: Search_History_Key,
    data: newList,
  });
  return true;
}

function clearSearchHistory() {
  try {
    wx.removeStorageSync(Search_History_Key);
  } catch (e) {
    return false;
  }
  return true;
}

function fetchSearchHistory() {
  let value = getYHStorageSync(Search_History_Key,'search')
  if (value) {
    return value;
  }
  return [];
}


module.exports = {
  addSearchHistory,
  removeSearchHistory,
  clearSearchHistory,
  fetchSearchHistory,
};